'
'******************************************************************************
'******************************************************************************
'******************************************************************************
'
'                             H E K T O R - 1 2 8
'       Sprachverschlssler mit Zeittransposition und Frequenzvariation
'
'******************************************************************************
'******************************************************************************
'******************************************************************************
'
'GPL-Erklrung HEKTOR-Software fr AVR - (C) 2004 - 2007 Julien Thomas
'
'Dieses Programm ist freie Software. Sie knnen es unter den Bedingungen der
'GNU General Public License (Free Software Foundation) weitergeben und/oder
'modifizieren, entweder unter Version 2 der Lizenz oder jeder spteren Version.
'Die Verffentlichung von Programm und Hardwaredokumentation erfolgt in der
'Hoffnung, dass es Ihnen von Nutzen sein wird, aber OHNE JEDE GEWHRLEISTUNG -
'sogar ohne die implizite Gewhrleistung von MARKTREIFE oder der EIGNUNG FR
'EINEN BESTIMMTEN ZWECK. Details finden Sie in der GNU General Public License.
'
'------------------------------------------------------------------------------
'------------------------------------------------------------------------------
'                           B a s c o m - B A S I C
'------------------------------------------------------------------------------
'------------------------------------------------------------------------------
'
'
$regfile = "m8515.dat"
$crystal = 10000000                          'Quarzfrequenz 10 MHz
$baud = 19200
$hwstack = 32
$swstack = 32
$framesize = 32
'
' Konstanten
'
Const Isrfreq = 135                          'mittlere ISR-Frequenz (96kHz)
'
' Byte-Variable und Austauschregister mit Maschinenroutinen
'
Dim A As Byte At $60
Dim B As Byte At $61
Dim Ttime As Word At $60 Overlay
Dim C As Byte At $62
Dim I As Byte At $63
Dim Z As Byte At $64
'
' 8 x Byte-Variable als 64 (63) Bit Schieberegister
'
Dim Q0 As Byte At $65
Dim Q1 As Byte At $66
Dim Q2 As Byte At $67
Dim Q3 As Byte At $68
Dim Q4 As Byte At $69
Dim Q5 As Byte At $70
Dim Q6 As Byte At $71
Dim Q7 As Byte At $72
'
' SRAM-Speicherpltze zur Parameterbergabe an Maschinenroutinen
'
Dim Bic As Byte At $73
Dim Dby As Byte At $74
Dim Zhi As Byte At $75
Dim Zhk As Byte At $76
Dim Fre As Byte At $77
Dim Blc As Byte At $78
Dim Sym As Byte At $79
'
' Transpositionstabelle und Frequenztabelle je 128 Byte
'
Dim T(128) As Byte At $080                   'Wertebereich 0-127
Dim F(128) As Byte At $100                   'Wertebereich 0-63
'
'
'
'------------------------------------------------------------------------------
' VERWENDUNG DER PORTLEITUNGEN BEIM ATMEGA8515 (Hardware V1.0b, PCB V1.0)
'------------------------------------------------------------------------------
'
' PA0-7  : Adress-/Datenbus Multiplex
'
' PB0,1,2: Tastenfeld Spalte
' PB4-7  : Tastenfeld Zeile
'
' PB2,3  : DM-Komparatoreingnge AIN0, AIN1
' PB1    : /PTT-in (Senden = Leitung auf Masse ziehen)
'
' PC0-7  : Adressbus Adressbit A8-A15 (A15 ungenutzt)
'
' PD0,1  : RS232 RXD/TXD
' PD2    : Ausgang Sync-LED
' PD3    : Eingang Sync
' PD4    : Ausgang DM-Loop
' PD5    : Ausgang DM-Audio
' PD6,7  : SRAM-WRITE (/WR), SRAM-READ (/RD)
'
' PE0    : Ausgang PTT (nicht invertiert: High=Tx, Low=Rx)
' PE1    : Adress-Latch-Enable (ALE)
' PE2    : Ausgang High=Aktivmodus, Low=Transparent
'
'
'------------------------------------------------------------------------------
' STUFE 0: Initialisierung
'------------------------------------------------------------------------------
'
Init:
'
Disable Interrupts
Disable Timer0
    Ddrd = &B11110110
   Portd = &B00001010
    Ddre = &B00000111
   Porte = &B00000010
    Ddrb = &B10000000
   Portb = &B00000001

On Timer0 Deltafix Nosave                    'Timer0-Interruptroutine
Config Timer0 = Timer , Prescale = 1         'ISR fr Delta- u. XRAM-Zugriffe
'
Waitms 100
Ttime = 200 : Gosub Beep                     'Signal "S" - Start
Waitms 100
Ttime = 200 : Gosub Beep
Waitms 100
Ttime = 200 : Gosub Beep
'
Gosub Xrush                                  'XRAM initialisieren
'
'
'
'------------------------------------------------------------------------------
' STUFE 1: Codeeingabe
' Eingabe der Startzahl fr Pseudozufallssequenz zur Tabellentransposition
'------------------------------------------------------------------------------
'
Pn_eingabe:
Do
Gosub Keypad                                 'Abfrage Tastenfeld, Ergebnis in C
If C = 11 Then Goto Deltatest                'wenn "#", Testmodus
If C = 10 Then Goto Pnc                      'wenn "*", Start Codeeingabe
Loop
'
Pnc:
Gosub Tabularasa                             'Alle Schlssel lschen
Ttime = 800 : Gosub Beep
While C <> 255 : Gosub Keypad : Wend
'
Kploop:
Do
   Gosub Keypad
   If C = 255 Then Goto Kploop
   Ttime = 150 : Gosub Beep
   If C = 10 Then Goto Pnc                   ' "*" = Nochmal neu anfangen
   If C = 11 Then Exit Do                    ' "#" = Eingabe besttigen
   Gosub Sr64shift                           'Vier Bits in Register
   Gosub Sr64shift                           'nach links schieben,
   Gosub Sr64shift                           'wenn weitere Zahl vorliegt
   Gosub Sr64shift
   Q0 = Q0 Or C                              'Bitmuster einschreiben
Loop

If Q7.7 = 1 Then                             'Falls Bit 63 gesetzt ist,
   Q0 = Not Q0                               'alle Register
   Q1 = Not Q1                               'invertieren
   Q2 = Not Q2                               'fuer erweiterten Wertebereich
   Q3 = Not Q3
   Q4 = Not Q4
   Q5 = Not Q5
   Q6 = Not Q6
   Q7 = Not Q7
   Q7 = Q7 And 63                            'verhindert "Leerlaufen" des LFSR
End If

Gosub Milestone                              'Erste 128 Tabellentranspositionen
'
'
'
'------------------------------------------------------------------------------
' STUFE 2: A k t i v m o d u s
' Ablaufsteuerung, Tastenabfrage, Signale auswerten, Schlsselverwaltung
'------------------------------------------------------------------------------
'
Active:
Porte.2 = 1                                  'Steuerleitung "Aktiv" einschalten
Gosub Deltainit
'
Rxtx_ready:
Porte.0 = 0                                  'Wartemodus immer PTT=0 (Empfang)
Gosub Deltaoff
'
If Pinb.0 = 0 Then Goto Init                 'Transparentmodus, Neustart
If Pinb.1 = 0 Then Gosub Txmatrix            'Sprechtaste gedrckt?
'
A = 0
   Do
   A = A + 1
   Gosub Rxsync_cycle
   ' Printbin C;
   Loop Until C < 50 Or C > 55 Or A > 20
   If A < 20 Then Goto Rxtx_ready
   Gosub Rxmatrix
Gosub Xrush
Goto Rxtx_ready
'
'
' -----------------------------------------------------------------------------
' STUFE 3 a - S e n d e n
' -----------------------------------------------------------------------------
'
Txmatrix:
Gosub Xrushsync
Porte.0 = 1                                  'PTT auf 1 (Senden)
'
Txmtt:
Gosub Deltaon                                'Delta-ISR freigeben
While Sym = 0 : Wend
While Sym > 0 : Wend
Gosub Deltaoff
'
If Pinb.1 = 1 Then                           'Sprechtaste losgelassen?
      Ttime = 80 : Gosub Txsync_hi           'Wenn ja, erst noch
      Gosub Transtable                       'letzte Tabelle erzeugen
      Gosub Deltaon                          'und letzten Block senden
      While Sym = 0 : Wend
      While Sym > 0 : Wend
      Gosub Deltaoff
      Ttime = 2500 : Gosub Txsync_hi         'langer Sync = Durchgang Ende
      Gosub Milestone
      Return                                 'Zurck nach RxTx_Ready
End If
Ttime = 80 : Gosub Txsync_hi
Gosub Transtable                             'Nchste Tabelle transponieren
Goto Txmtt
'
'
' -----------------------------------------------------------------------------
' STUFE 3 b : E m p f a n g e n
' -----------------------------------------------------------------------------
'
Rxmatrix:
Gosub Rxsync_hi                              'Restlichen Start-Sync abwarten
Gosub Transtable
Gosub Rxsync_hi                              'Ersten Blocksync abwarten
Waitms 5
'
Rxmtt:
Gosub Deltaon                                'Delta-ISR freigeben
While Sym = 0 : Wend
While Sym > 0 : Wend
Gosub Deltaoff
Waitms 10
If Pinb.0 = 0 Then Return                    'Neustart
If Pinb.2 = 0 Then Return                    '# Abbruch gewnscht
Gosub Rxsync_hi
If C = 255 Then
      'Gosub Transtable
      'Gosub Deltaon
      'While Sym = 0 : Wend
      'While Sym > 0 : Wend
      'Gosub Deltaoff
      'Gosub Rxsync_hi            'Rest vom Endsync abwarten
      Gosub Milestone                        'Nchsten Bezugspunkt anfahren
      Return                                 'Zurck in Warteschleife
End If
If C < 10 Then Waitms 20                     'evtl. fehlenden Sync berbrcken
Gosub Transtable
Goto Rxmtt
'
'
'
'------------------------------------------------------------------------------
' Deltamodulation einschalten / passivschalten (Ports tristate)
'------------------------------------------------------------------------------
'
Deltainit:
Enable Timer0
!ldi zl, 0
!ldi zh, 128
!ldi xl, 128
!ldi xh, 1
Zhi = 128
Zhk = 128
Sym = 0
Return
'
'
'------------------------------------------------------------------------------
'
Deltaoff:
Disable Interrupts
  Acsr = &B00000000                          'Analogkomparator aus
  Ddrd = &B11000110
 Portd = &B11001110
  Ddrb = &B11110000
 Portb = &B00000111
   !cbi mcucr, 7                             'XRAM-Zugriff sperren fr
   !cbi mcucr, 6                             'sicheren internen SRAM-Zugriff
Return
'
'
'------------------------------------------------------------------------------
Deltaon:
  Ddrd = &B11110110                          'diverse PORTD-Register
 Portd = &B11001010
  Ddrb = &B11110000
 Portb = &B00000001
  Acsr = &B00100000                          'Analogkomparator ein
   !sbi MCUCR,7                              'XRAM-Zugriffe
   !SBI MCUCR,6                              'wieder erlauben
Fre = Isrfreq + 32
Enable Interrupts
Return
'
'
'------------------------------------------------------------------------------
Deltatest:
Gosub Tabularasa
Gosub Milestone
Gosub Xrushsync
Gosub Deltainit
Blc = 0
Gosub Deltaon
While A = A : Wend
End
'
'
'
'------------------------------------------------------------------------------
'------------------------------------------------------------------------------
'                     M a s c h i n e n s p r a c h e
'------------------------------------------------------------------------------
'------------------------------------------------------------------------------
'
'
'------------------------------------------------------------------------------
' ISR: Deltamodulation + SRAM-Schreib/Lesezugriffe nach Tabelle
'------------------------------------------------------------------------------
Deltafix:
$asm                                         'Bitte anschnallen !
'
.def Tmp = R16                               'Universalregister
.def Dby = R8                                'Deltabyte
.def Bic = R9                                'Bitcount

      push Tmp
      iN Tmp,SREG                            'Statusregister sichern
      push tmp
      lds Tmp, $77                           'Timerwert nach Frequenztabelle
      Out Tcnt0 , Tmp

Dreg:
      nop                                    'Zur Feinabstimmung
      nop                                    'bei weiteren nderungen
      nop                                    'in der ISR
      nop
      nop
      nop
      nop
      nop
      nop

Delta:
      Clc                                    'Carry lschen
      sbic ACSR,5                            'Bei Delta=0 weiterspringen
      rjmp Rec1                              'Sprung nach Rec1
Rec0:
      cbi portd,4                            'Delta-Feedback auf 0
      brcc Recx                              'Carry ist gelscht
Rec1:
      sec                                    'Carry setzen
      Sbi portd,4                            'Delta-Feedback auf 1
Recx:
      roL Dby                                'Deltabyte neues Bit vorn rein,
      brcS Play1                             'hinten altes Bit raus!
Play0:
      Cbi Portd, 5
      brcc Bitcount
Play1:
      sbi portd, 5

Bitcount:
      inc Bic                                'Bitzhler runterzhlen
      sbrs Bic, 3                            'wenn Bit 3 noch nicht gesetzt,
      rjmp Xrexit                            'ISR bereits fertig, sonst
      clr Bic                                'Zugriffe auf XRAM durchfhren
Xrama:
      sbi mcucr, 7                           'XRAM-Zugriffe
      Lds tmp, $78                           'Blc zur Bankumschaltung in tmp
Xrrxtx:
      sbIc pINE, 0                           'PE.0 = 0 - Rx / PE.0 = 1 - Tx
      rjmp XrTx
Xrrx:
      sbrC tmp, 0
      sbr zl, 128
      lds zh, $76                            'Rx-Transposition:
      st z, Dby                              'diskontinuierlich schreiben
      sbr zl, 128
      sbrC tmp, 0
      cbr zl, 128
      lds zh, $75                            'und kontinuierlich lesen
      ld Dby, z
      rjmp Xraddr
Xrtx:
      sbrc tmp, 0
      sbr zl, 128
      lds zh, $75                            'Tx-Transposition:
      st z, Dby                              'kontinuierlich schreiben
      sbR zl, 128
      sbrc tmp, 0
      cbr zl, 128
      ldS zh, $76                            'und diskontinuierlich lesen
      ld Dby, z
      nop
      nop
Xraddr:
      cbr zl, 128
      cbi mcucr, 7                           'XRAM-Zugriffe abschalten
Xradx:
      inc zl
      cpi zl, 128
      brne Xrexit
      clr zl
      lds xl, $75
      inc xl
      Brne Xrady
      ldi xl, 128
Xrady:
      ldi xh, 0                              'Tabellenzugriff $80-$FF
      ld tmp, x                              'Tabelleneintrag holen
      sts $76, tmp                           'Transpositionszeiger XRAM
      sts $75, xl                            'Fortlaufender Zhler XRAM
      andi xl, 127                           'Bit 7 von xl lschen
      sts $79, xl                            'Sym fr Basic

      lds tmp, $78                           'Blockzhler abfragen
      and tmp, tmp                           'Wenn Block 0, dann
      breq Xrexit                            'Festfrequenz benutzen, sonst
      ldi xh,1                               'Tabellenzugriff $100-$180
      ld tmp, x                              'Frequenzwert holen
      sts $77, tmp                           'und in $77 laden
Xrexit:
      pop Tmp                                'Statusregister
      Out Sreg , Tmp                         'wiederherstellen
      pop Tmp
      reti
      $end Asm
Return                                       'Wir drfen wieder bummeln ...
'
'
'
'------------------------------------------------------------------------------
' XRAM INITIALISIEREN
'------------------------------------------------------------------------------
$asm
' berschreiben mit Bitmuster 01010101 = Delta-Mittelwert
Xrush:
      push r16
      sbi mcucr, 7
      ldi r16, &b01010101
      clr zl
      ldi zh, 128
Xrl:
      st z, r16
      inc zl
      brne Xrl
      inc zh
      brne Xrl
Xrx:
      cbi mcucr, 7
      pop r16
      ret
'
' berschreiben mit 4 x $FF, 4 x $00 = Frequenzwert 1/8 Taktrate
'
Xrushsync:
      push r16
      sbi mcucr, 7
      clr r16
      clr zl
      ldi zh, 128
Xrsl:
      com r16
      st z+, r16
      st z+, r16
      st z+, r16
      st z, r16
      inc zl
      brne Xrsl
      inc zh
      brne Xrsl
Xrsx:
      cbi mcucr, 7
      pop r16
      ret
'
'
'------------------------------------------------------------------------------
'TASTENFELD
'------------------------------------------------------------------------------
'Abfrage 3x4 Matrix an PORTB (PB0,1,2,-,4,5,6,7)
'bei Doppelbelegung von PB1, AIN0, AIN1 (geht nicht mit GETKB() ...)
'Ausgabewerte in $62:  0 - 9   /   * = 10   /   # = 11   /   Keine = 255
'------------------------------------------------------------------------------
'
Keypad:
      push r16
      push r17
      push r18

      ldi r16, &B11111000
      Out Ddrb , R16
Keyp0:
      ldi r18,9
      ldi r16, &B01111111
      Out Portb , R16
      rCall Pause
      in r17, pinb
      CPse r17, r16
      rjmp Keyp1
      ldi r18,6
      ldi r16, &B10111111
      Out Portb , R16
      rcall Pause
      in r17, pinb
      CPse r17, r16
      rjmp Keyp1
      ldi r18,3
      ldi r16, &B11011111
      Out Portb , R16
      rcall Pause
      in r17, pinb
      CPse r17, r16
      rjmp Keyp1
      ldi r18,0
      ldi r16, &B11101111
      Out Portb , R16
      rcall Pause
      in r17, pinb
      CPse r17, r16
      rjmp Keyp1
      ser r18
      rjmp KeypX
Keyp1:
      AndI r17, 7
      Inc r18
      cpi r17, 6
      breq Keyp2
      inc r18
      CPI r17, 5
      breq Keyp2
      inc r18
      CPI r17,3
      breq Keyp2
      brne Keyp0
Keyp2:
      cpi r18, 11
      brne Keyp3
      ldi r18, 0
      rjmp Keyp4
Keyp3:
      cpi r18, 12
      brne Keyp4
      dec r18
Keyp4:
      in r17, pinb
      andi r17,7
      cpI r17, 7
      brne Keyp3
Keypx:
      ser r17
      Out Portb , R17
      sts $62, r18                           'Tastencode in Bytevariable C
      pop r18
      pop r17
      pop r16
      ret
'
'
'
'------------------------------------------------------------------------------
' PAUSE von ca. 20 Millisekunden (z.B. Tastenfeld entprellen)
'
Pause:
      push r16
      push r17
      CLR r16
      CLR r17
Pl:
      dec r16
      brne Pl
      dec r17
      brne Pl
      pop r17
      pop r16
      ret
'
'
'------------------------------------------------------------------------------
' STANDARDVERZGERUNG 18 Takte (fr Monoflop-Routinen)
'
Nopnop:
      nop
      nop
      nop
      nop
      nop

      nop
      nop
      nop
      Nop
      nop

      nop
      nop
      nop
      nop
      nop

      nop
      nop
      nop

      ret
'
'
'------------------------------------------------------------------------------
' DETEKTION UND AUSWERTUNG DER SYNCHRONISATIONSSIGNALE
'------------------------------------------------------------------------------
' Rxsync_cycle:  Ermittelt Periodendauer von Eingangssignal an PORTD.3
'                ber mehrere Perioden, Ergebnis in $62
'------------------------------------------------------------------------------
'
Rxsync_cycle:                                'Messen der Periodendauer
      push r16
      push r17
      push r18

      sbi portd,3                            'Synchro-PORTD.3
      cbi ddrd,3                             'auf Eingang mit Pullup

      clr r16
      clr r17
      ldi r18, 12                            'Anzahl Messungen

Rxscloop:
Rxscl1:
      inc r16
      brne Rxscl1a
      inc r17
      breq Rxscx
Rxscl1a:
      sbic pind,3
      rjmp Rxscl1
Rxscl0:
      inc r16
      brne Rxscl0a
      inc r17
      breq Rxscx
Rxscl0a:
      sbis pind, 3
      rjmp Rxscl0
      dec r18
      brne Rxscloop
Rxscx:
      sts $62, r17                           'Ergebnis in Bytevariable C
      pop r18
      pop r17
      pop r16
      ret
'
'
'------------------------------------------------------------------------------
' SYNCHRO-ENDE-ERKENNUNG (Monoflop + berlnge erkennen)
'------------------------------------------------------------------------------
'
Rxsync_hi:
      push r16
      push r17
      sbi portd,3                            'Synchro-PORTD.3
      cbi ddrd,3                             'als Eingang mit Pullup
      clr r17
Rxshloop:
      clr r16
      cpi r17, 255
      breq Rxshl
      inc r17
Rxshl:
      sbiC pind,3
      rjmp Rxsh1
Rxsh0:
      rcall Nopnop
      sbiC pind,3
      rjmp Rxsh1
      dec r16
      brne Rxsh0
      rjmp Rxshex
Rxsh1:
      rcall Nopnop
      sbiS pind,3
      rjmp Rxshloop
      dec r16
      brne Rxsh1
Rxshex:
      sts $62, r17
      pop r17
      pop r16
      ret
'
'
'------------------------------------------------------------------------------
' SYNC SENDEN (Dauer = Word "TTime")
'------------------------------------------------------------------------------
'
Beep:
      cbi Porte,0
Txsync_hi:

      push r16
      push r17
      push r18

      Clr R16

      sbi ddrd,5                             'PORTD.5 auf Ausgang setzen

      lds r17, $60                           '16-Bit-Variable "Ttime"
      lds r18, $61                           'bernehmen
      inc r18

Txshl:
      dec r16

      nop                                    '9 x NOP fr 1625 Hz @ 10 MHz
      nop
      nop
      nop
      nop

      nop
      nop
      nop
      nop

      brne Txshl

      sbIs PIND,5                            'PORTD.5 umtasten (Tonerzeugung)
      sbi portd,5
      SbIC PIND,5
      cbi portd,5

      dec r17
      brne Txshl
      dec r18
      brne Txshl

Txshx:
      cbi portd,5
      Cbi ddrd,5                             'PORTD.5 wieder tristate

      pop r18
      pop r17
      pop r16
      ret
'
'
'
'------------------------------------------------------------------------------
' LFSR-GESTEUERTE TABELLENTRANSPOSITIONEN (128 Elemente)
'------------------------------------------------------------------------------
' Transtable: Tabellentransposition nach Pseudozufallssequenz aus SR
'             Blockzhler in Word BLC ($78/$79)
'             Wichtig: XRAM-Zugriffe mssen gesperrt sein (MCUCR)
' SR64shift : SR-Linksschieben (betrifft Bytes in $65 bis $72 und Carry)
' Milestone : Tabellentranspositionen bis zur nchsten 256er-Einheit
' Tabularasa: Lschen von Schieberegister, Blockzhler und Tabellen
'------------------------------------------------------------------------------
'
Transtable:
.def Tmp = R16
.def Li = R17
.def Lz = R18

      push r0
      push r1
      push r2
      push r3
      push r4
      push r5
      push r6
      push r7

      push r20
      push r21

      push tmp
      push li
      push lz

      lds r0, $65                            'Laden der Bytevariable Q0-Q7
      lds r1, $66                            'in Register R0-R7
      lds r2, $67                            'fr schnelle Registerschiebereien
      lds r3, $68
      lds r4, $69
      lds r5, $70
      lds r6, $71
      lds r7, $72

      ldi lz, 128                            'Schleifenzhler beginnt bei 128

Ttloopz:
      clr li
Ttloopi:
      clr tmp                                'XNOR-Verknpfung von
      sbrC r7, 6                             'Bit 63 (Bit 6 von Q7)
      inc tmp                                'tmp hochzhlen (=toggle Bit 0)
      Sbrc r7, 5                             'Bit 62 (Bit 5 von Q7)
      inc tmp                                'tmp hochzhlen (=toggle Bit 0)
      clc
      sbrs tmp, 0                            'nur Bit 0 auswerten
      sec                                    'Ergebnis steht im Carry

      rol r0                                 'Linksschieben
      rol r1                                 'durch alle 8 Register des LFSR
      rol r2
      rol r3
      rol r4
      rol r5
      rol r6
      rol r7                                 'Carry (64.Bit) darf rausfallen

      inc li                                 'Innere Schleife:
      cpi li, 13                             '13 Mal Linksschieben
      brne TTLoopi

      ldi xh, 0                              'Tabelle liegt ab $80 (128)

      mov xl, lz                             'Tabellenindex LZ
      ld r20, x                              'Tabelleneintrag in R20 laden
      mov xl, r0                             'Tabellenindex aus LSFR-R0
      ori xl, 128                            'XL-Bit 7 setzen
      ld r21, x                              'Tabelleneintrag in R21 laden
      St x, r20                              'R20 an diese Stelle schreiben
      mov xl, lz                             'Tabellenindex LZ
      St x, r21                              'R21 an diese Stelle schreiben

      inc lz                                 '128 Transpositionen (128-255)
      breq TTLxx                             'wenn fertig, weiter bei TTLXX
      rjmp TTLoopz                           'ansonsten neue Runde

Ttlxx:
      lds tmp, $78                           'Lowbyte Blockzhler
      inc tmp
      sts $78, tmp                           'und in Bytevariable BLC sichern

Ttlxy:
      sts $65, r0                            'Zum Schluss R0-R7 wieder in
      sts $66, r1                            'Bytevariable Q0-Q7 sichern
      sts $67, r2
      sts $68, r3
      sts $69, r4
      sts $70, r5
      sts $71, r6
      sts $72, r7

      pop lz
      pop li
      pop tmp

      pop r21
      pop r20

      pop r7
      pop r6
      pop r5
      pop r4
      pop r3
      pop r2
      pop r1
      pop r0

      ret
'
'
'------------------------------------------------------------------------------
' Lschen aller Registervariable, Transpositionstabelle neu initialisieren
'
Tabularasa:
      push r16
      clr r16                                'Lschen aller PN-Register $65-$72
      sts $65, r16
      sts $66, r16
      sts $67, r16
      sts $68, r16
      sts $69, r16
      sts $70, r16
      sts $71, r16
      sts $72, r16

      sts $78, r16                           'Blockzhler $78 ebenfalls lschen

      ldi xh, 0
      ldi xl, 128
Tblrx:
      st x, xl                               'Tabelle mit Werten 128-255 fllen
      inc xl
      brne Tblrx

      pop r16
      ret
'
'
'------------------------------------------------------------------------------
' Nchster Halt (128'er-Sprung) und Bereitstellung der neuen Frequenztabelle
'
Milestone:
      push R16
      push R17
Mstt1:
      rcall Transtable                       'Tabelle transponieren
      lds r16, $78                           'Variable Blc laden
      andi r16, 63                           'nchste volle 64'er-Einheit
      brne Mstt1                             'durchtransponieren

Msfreqtable:
      ldi r17, Isrfreq                       'Frequenzbasiswert fr ISR
      clr xl
Msftt:
      ori xl, 128                            'Zugriff auf Transpositionstabelle
      ldi xh, 0                              'T(x) von $080-$0FF
      ld r16, x
      andi r16, 63                           'Wertebereich 0-63
      Add r16 , r17                          'Frequenzbasis plus Tabellenwert
      andi xl, 127                           'Zugriff auf Frequenztabelle
      ldi xh, 1                              'F(x) von $100-$1FF
      st x, r16
      inc xl
      cpi xl, 128
      brne Msftt
Mstt2:                                       'weitere 64 Tabellen berspringen
      rcall Transtable
      lds r16, $78
      andi r16, 63
      brne Mstt2

Msx:
      clr r16                                'Blockzhler zurcksetzen
      sts $78, r16

      pop R17
      pop R16
      ret
'
'
'------------------------------------------------------------------------------
' Schnelle Schieberoutine fr Basic
'
Sr64shift:
      push r16
      clc
      lds r16, $65                           'Registerbyte Q0
      rol r16                                'Carry bernehmen, linksschieben
      sts $65, r16                           'und sichern
      lds r16, $66                           'Registerbyte Q1
      rol r16                                'Carry bernehmen, linksschieben
      sts $66, r16                           'und sichern
      lds r16, $67                           'Registerbyte Q2
      rol r16                                'Carry bernehmen, linksschieben
      sts $67, r16                           'und sichern
      lds r16, $68                           'Registerbyte Q3
      rol r16                                'Carry bernehmen, linksschieben
      sts $68, r16                           'und sichern
      lds r16, $69                           'Registerbyte Q4
      rol r16                                'Carry bernehmen, linksschieben
      sts $69, r16                           'und sichern
      lds r16, $70                           'Registerbyte Q5
      rol r16                                'Carry bernehmen, linksschieben
      sts $70, r16                           'und sichern
      lds r16, $71                           'Registerbyte Q6
      rol r16                                'Carry bernehmen, linksschieben
      sts $71, r16                           'und sichern
      lds r16, $72                           'Registerbyte Q7
      rol r16                                'Carry bernehmen, linksschieben
      sts $72, r16                           'und sichern
      pop r16
      ret
$end Asm
'
'------------------------------------------------------------------------------
'
'
' ENDE 'HEKTOR' PROGRAMMCODE FR BASCOM-AVR
'
'------------------------------------------------------------------------------
'Auszugsweise Tabellenausgabe ber RS232,
'einzufgen an entsprechender Programmstelle
'
'For I = 1 To 64 : A = T(i) And 127 : A = A Or 64 : Printbin A ; : Next I:Print
'